//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  mem.hpp
//! \brief Declare online memory

#ifndef MEM_H
#define MEM_H

#include "ptr.hpp"
#include "registry.hpp"

class COlo;
class COld;
class COlc;

//! Online memory and the default file selection.

class SMem : public triv::ISingleton<SMem>
{
private:
    vector<POlo> MOM;
    vector<POlo> BAK;

public:
    bool overwrite;

    // Read from online memory:
    COlo* mem_get(int k) const;
    COld* mem_get_D(int k) const;
    COlc* mem_get_C(int k) const;
    int mem_size() const;

    // Modify online memory (file selection is changed accordingly):
    void mem_store(POlo&& olo, int k = -1);
    void mem_del(int k);
    void mem_xchange();
    void mem_copy();
};

#endif // MEM_H
