//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  plowin.hpp
//! \brief declares SPloWin, to administer plot windows

#include "../trivia/singleton.hpp"
#include <memory>
#include <vector>

class CPlot;

class SPloWin : public triv::ISingleton<SPloWin>
{
private:
    std::vector<CPlot*> Plots;
    int iPlot; //!< current plot window
public:
    ~SPloWin();
    static void initialize();
    CPlot* current() { return Plots[iPlot]; }
    void select(int i);
    int nPlot() const { return Plots.size(); }
    void display_list() const;
};
