//***************************************************************************//
//* libtrivia: various little routines for C++                              *//
//* math: mathematical operations                                           *//
//* (C) Joachim Wuttke 2001, 2012-                                          *//
//* http://apps.jcns.fz-juelich.de                                          *//
//***************************************************************************//

#include "math.hpp"
#include <cmath>

//***************************************************************************//
//*  rounding                                                               *//
//***************************************************************************//

//! Round given value to given number of digits.

double triv::round_decimal(double val, double digits)
{
    if (val == 0 || digits <= 0)
        return 0;
    double v = fabs(val);
    int n = (int)floor(digits - log10(v));
    // cout << " n=" << n;
    double p = pow(10., n);
    double r = round(v * p) / p;
    return (val < 0 ? -1 : +1) * r;
}
